package comments;

import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.GregorianCalendar;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.TimeZone;

import javax.xml.bind.JAXBException;
import javax.xml.datatype.Duration;
import javax.xml.datatype.XMLGregorianCalendar;
import javax.xml.namespace.QName;

import org.docx4j.jaxb.Context;
import org.docx4j.openpackaging.exceptions.InvalidFormatException;
import org.docx4j.openpackaging.packages.WordprocessingMLPackage;
import org.docx4j.openpackaging.parts.JaxbXmlPart;
import org.docx4j.openpackaging.parts.WordprocessingML.CommentsPart;
import org.docx4j.openpackaging.parts.WordprocessingML.MainDocumentPart;
import org.docx4j.relationships.Relationship;
import org.docx4j.relationships.Relationships;
import org.docx4j.wml.Body;
import org.docx4j.wml.CommentRangeEnd;
import org.docx4j.wml.CommentRangeStart;
import org.docx4j.wml.Comments;
import org.docx4j.wml.Comments.Comment;
import org.docx4j.wml.ObjectFactory;
import org.w3c.dom.Node;

import com.sun.org.apache.bcel.internal.generic.NEWARRAY;
import com.sun.org.apache.xerces.internal.jaxp.datatype.XMLGregorianCalendarImpl;

import util.RelationshipName;

public class CommentRel {

	private WordprocessingMLPackage wordMlPackage;
	private MainDocumentPart mainPart;
	private boolean relSet = false;
	private org.docx4j.wml.ObjectFactory wmlObjectFactory;
	private CommentsPart cmPart;

	public CommentRel(WordprocessingMLPackage wordMLPack) {
		this.wordMlPackage = wordMLPack;
		setCommentRel();
		wmlObjectFactory = new ObjectFactory();
		cmPart = wordMlPackage.getMainDocumentPart().getCommentsPart();
		mainPart = wordMLPack.getMainDocumentPart();
	}

	private void setCommentRel() {
		if (!commentRelSet()) {
			CommentsPart cp;
			try {
				cp = new CommentsPart();
				// Part must have minimal contents
				wordMlPackage.getMainDocumentPart().addTargetPart(cp);
			} catch (InvalidFormatException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

	private boolean commentRelSet() {
		return !(wordMlPackage.getMainDocumentPart().getCommentsPart() == null);
	}

	public void addNewComment(String author, String text) {
		XMLGregorianCalendar xmlCal = new XMLGregorianCalendarImpl();
		CommentRangeEnd cRangeEnde = wmlObjectFactory.createCommentRangeEnd();
		CommentRangeStart cRangeStart = wmlObjectFactory
				.createCommentRangeStart();
		Comments comment = wmlObjectFactory.createComments();
//		Comments.Comment myCom = wm

		Comment c = Context.getWmlObjectFactory().createCommentsComment();
		System.out.println("test");
		comment.setParent(cmPart);
		c.setAuthor(author);
		c.setDate(xmlCal);
		c.getEGBlockLevelElts().add(c);

		System.out.println("test ende");
	}
}
